#if !defined(__FLLOPVEC_H)
#define __FLLOPVEC_H
#include "fllopsys.h"

FLLOP_EXTERN PetscErrorCode VecMergeAndDestroy(MPI_Comm comm, Vec *local, Vec *global);
FLLOP_EXTERN PetscErrorCode VecPrintInfo(Vec vec);
FLLOP_EXTERN PetscErrorCode ISCreateFromVec(Vec vec, IS *is);
FLLOP_EXTERN PetscErrorCode VecConcat(Vec a, Vec b, PetscInt m, Vec *newab);
FLLOP_EXTERN PetscErrorCode VecInterleave(MPI_Comm comm,PetscInt nvecs,Vec vecs[], Vec *newv, IS *map);

#endif
