#if !defined(__FLLOPMATIMPL_H)
#define	__FLLOPMATIMPL_H
#include <fllopmat.h>
#if PETSC_VERSION_MINOR==1 || PETSC_VERSION_MINOR==2
#include <private/matimpl.h>
#else
#include <petsc-private/matimpl.h>
#endif


typedef struct {
  KSP          ksp, ksp_block;
  MatInvType   type;
} Mat_Inv;

typedef struct {
	Mat localBlock;	/* local (sequential) blocks of BlockDiag */
  PetscInt firstElemGlobIdx[2];
	Vec right_loc,  left_loc;        
} Mat_BlockDiag;

FLLOP_EXTERN PetscLogEvent Mat_Gather, Mat_CopyLocal, Mat_OrthColumns, Mat_Inv_Explicitly, Mat_Inv_SetUp, Mat_Regularize;

#endif
