#if !defined(__MPGPIMPL_H)
#define __MPGPIMPL_H
#include <private/qpsimpl.h>

typedef struct
{
  Vec      I;     /* ... indices with inequality */
  Vec      A;     /* ... active set indices      */
  Vec      F;     /* ... free indices            */
  Vec      B;     /* ... free with g_i>0         */
} Set;

typedef struct
{
  Vec      P;     /* ... projected gradient      */
  Vec      C;     /* ... chopped gradient        */
  Vec      F;     /* ... free gradient           */
  Vec      R;     /* ... reduced free gradient   */
} Grad;

typedef struct {
  PetscReal gamma;
} QPS_MPGP;

#endif
