#ifndef __COMPARATOR_H
#define __COMPARATOR_H

// http://www.linuxselfhelp.com/HOWTO/C++Programming-HOWTO-17.html

#include "plocha.h"
#include <string.h>

#define _INC(i1,i2)i1++;i2++;

class Comparator
{
private:
	// funkce resi problem porovnani dvou poli, ktere maji ruzny pocet hodnot
	// a rozhoduje ktere znich je vetsi
	// vraci true pokud je p1 vetsi nez p2
	short index1;
	short index2;
	bool mycmp(const Plocha * p1, const Plocha * p2)
	{
		index1 = 0;
		index2 = 0; 
		if (p1->pbp > p2->pbp)
		{
			while (index1 < p1->pbp && index2 < p2->pbp)
			{
				if (p1->bodyp[index1] > p2->bodyp[index2])  
					return (index1 == index2);
				else if ( p1->bodyp[index1] == p2->bodyp[index2] ){
					_INC(index1,index2);				
				}
				else index1++;
			}	
		}	
		else			// p1->pbp < p2->pbp
		{
			while (index1 < p1->pbp && index2 < p2->pbp)
			{
				if (p1->bodyp[index1] > p2->bodyp[index2])
					index2++;
				else if ( p1->bodyp[index1] == p2->bodyp[index2] ){
					_INC(index1,index2);				
				}
				else return (index1 < index2);
			}
		}
		return (index1 < p1->pbp);	// true -> p1 > p2
	}

public:
	// vrcen hodnota je true pokud je p2 > p1
	bool operator()(const Plocha * p1, const Plocha * p2)
    { 		
		if (p1->pbp == p2->pbp)
			return (memcmp(p2->bodyp, p1->bodyp, p1->pbp * sizeof(long)) > 0);
		
		// pozor na poradi argumentu
		return mycmp(p2, p1);
	}
};
#endif


